C===================================================================
C
      PROGRAM RECT1
C
C  This program creates the INPUTFILE for LABECON when the 
C  domain is a rectangle AA*BB
C    
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*15 INPUTFILE 
      CHARACTER*80 NAME,TITLE
      PARAMETER (N=16)
      PARAMETER (IN=9)
      DIMENSION XL(N+1),YL(N+1),XIN(IN),YIN(IN)
      DIMENSION ICODE(N),UB(N)
C      
      WRITE (*,'(A)')' Name of the INPUTFILE (max.15 characters)'
      READ  (*,'(A)') INPUTFILE
      OPEN (1, FILE=INPUTFILE)
      WRITE (*,'(A)')' User NAME (max.15 characters)'
      READ(*,'(A)')NAME
      WRITE(1,'(A)')NAME
      WRITE (*,'(A)')' Program TITLE (max.15 characters)' 
      READ(*,'(A)')TITLE
      WRITE(1,'(A)')TITLE
C      
      WRITE(1,100)
  100 FORMAT(' ',79(' '))
C
C  Boundary coordinates  
C    
      AA=1.
      BB=1.
      NX=4
      NY=4
      DA=AA/NX
      DB=BB/NY
      DO 1 I=1,NX      
      XL(I)=(I-1)*DA
      YL(I)=0.      
    1 WRITE(1,300)XL(I),YL(I)
  300 FORMAT(2(2X,F14.8))
C     
      DO 2 I=1,NY      
      XL(I+NX)=AA
      YL(I+NX)=(I-1)*DB
    2 WRITE(1,300)XL(I+NX),YL(I+NX)
C    
      DO 3 I=1,NX      
      XL(I+NX+NY)=AA-(I-1)*DA
      YL(I+NX+NY)=BB      
    3 WRITE(1,300)XL(I+NX+NY),YL(I+NX+NY) 
C    
      DO 4 I=1,NY      
      XL(I+NX+NY+NX)=0.
      YL(I+NX+NY+NX)=BB-(I-1)*DB
    4 WRITE(1,300)XL(I+NX+NY+NX),YL(I+NX+NY+NX)
C      
      WRITE(1,100)
C   
C Boundary conditions  
C
      DO 10 I=1,N
      ICODE(I)=0
   10 UB(I)=0.
      DO 20 I=1,N
   20 WRITE(1,400) ICODE(I),UB(I)
  400 FORMAT(I4,3X,F14.8)
C      
      WRITE(1,100)
C
C     Coordinates of the internal points
C
      IX=3
      JY=3
      DX=AA/(IX+1)
      DY=BB/(JY+1)
      WRITE(1,100)     
C
      DO 5 J=1,JY 
      DO 5 I=1,IX       
      K=(J-1)*JY+I
      XIN(K)=DX+(I-1)*DX
      YIN(K)=DY+(J-1)*DY
      WRITE(1,300)XIN(K),YIN(K)
    5 CONTINUE    
C      
      STOP
      END 
C
C===================================================================       